<template>
<div id="table" class="app-container calendar-list-container">
	    <!-- 查询和其他操作 -->
	    <div class="filter-container" style="margin: 10px 0 10px 0;">
        <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
          <el-form-item label="图集名称">
            <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.keyword" placeholder="请输入名称"></el-input>
          </el-form-item>
          <el-form-item label="图集创建时间" label-width="100px">
            <el-date-picker
              v-model="queryParams.createTime"
              class="baseInput"
              type="date"
              placeholder="请选择"
              format="yyyy-MM-dd"
              value-format="yyyy-MM-dd"
            />
          </el-form-item>
          <el-form-item label="图集图片更新时间" label-width="125px">
            <el-date-picker
              v-model="queryParams.storageTime"
              class="baseInput"
              type="date"
              placeholder="请选择"
              format="yyyy-MM-dd"
              value-format="yyyy-MM-dd"
            />
          </el-form-item>
          <el-form-item label="图集标签">
            <el-select
              v-model="queryParams.tagUid"
              class="filter-item"
              placeholder="请选择"
              style="width: 140px"
              filterable
              clearable
              remote
              reserve-keyword
            >
              <el-option
                v-for="item in tagData"
                :key="item.uid"
                :label="item.content"
                :value="item.uid"
              ></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="图集来源">
            <el-select
              v-model="queryParams.resource"
              class="filter-item"
              placeholder="请选择"
              style="width: 140px"
              filterable
              clearable
              remote
              reserve-keyword
            >
              <el-option
                v-for="item in resourceData"
                :key="item.resource"
                :label="item.resource"
                :value="item.resource"
              ></el-option>
            </el-select>
          </el-form-item>
          <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind" v-permission="'/pictureAtlas/getList'">查找</el-button>
          <el-button class="filter-item" type="primary" icon="el-icon-edit" @click="handleUpdateTag" v-permission="'/pictureAtlas/updateTag'">修改标签</el-button>
        </el-form>
	      <!--<el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit" v-permission="'/pictureAtlas/add'">添加</el-button>-->
	    </div>

  <!--列表信息-->
    <el-table :data="tableData" style="width:100%" @selection-change="handleSelectionChange">
      <el-table-column type="selection"></el-table-column>
      <!--<el-table-column label="序号" width="60" align="center">
	      <template slot-scope="scope">
	        <span >{{scope.$index + 1}}</span>
	      </template>
	    </el-table-column>-->

	   	<!--<el-table-column label="标题图" width="160" align="center">
	      <template slot-scope="scope">
	      	<img  v-if="scope.row.photoList" :src="scope.row.photoList[0]" style="width: 130px;height: 70px;"/>
	      </template>
	    </el-table-column>-->
	    <el-table-column label="图集名称" width="160" align="center">
	      <template slot-scope="scope">
	        <span @click="handleAtlas(scope.row)" style="background-color:#EAFBFF;">{{ scope.row.name }}</span>
	      </template>
	    </el-table-column>
      <el-table-column label="资源图集ID" width="300" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.uid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="资源图集标签" width="200" align="center" >
        <template slot-scope="scope">
          <template>
            <el-tag
              style="margin-left: 3px"
              type="warning"
              v-if="item"
              :key="index"
              v-for="(item, index) in scope.row.tagList"
            >{{item.content}}</el-tag>
          </template>
        </template>
      </el-table-column>
      <el-table-column label="图片数量" width="140" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.count }}</span>
        </template>
      </el-table-column>
      <el-table-column label="模特" width="140" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.model }}</span>
        </template>
      </el-table-column>
      <el-table-column label="出品商" width="160" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.producer }}</span>
        </template>
      </el-table-column>
      <el-table-column label="资源图集创建时间" width="160" align="center">
	      <template slot-scope="scope">
	        <span >{{ scope.row.createTime }}</span>
	      </template>
	    </el-table-column>

      <el-table-column label="图片最新更新时间" width="160" align="center">
        <template slot-scope="scope">
          <span >{{ scope.row.storageTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="来源" width="160" align="center">
        <template slot-scope="scope">
          <span >{{ scope.row.resource }}</span>
        </template>
      </el-table-column>

	   	<!--<el-table-column label="状态" width="100" align="center">
	   	  <template slot-scope="scope">
		   	  <template v-if="scope.row.status == 1">
		        <span>正常</span>
		      </template>
		      <template v-if="scope.row.status == 2">
		        <span>推荐</span>
		      </template>
		      <template v-if="scope.row.status == 0">
		        <span>已删除</span>
		      </template>
	   	  </template>
	    </el-table-column>-->

	    <!--<el-table-column label="操作" fixed="right" min-width="170">
	      <template slot-scope="scope" >
          <el-button @click="handleManager(scope.row)" type="success" size="small">图片列表</el-button>
	      	<el-button @click="handleEdit(scope.row)" type="primary" size="small" v-permission="'/pictureAtlas/edit'">编辑</el-button>
	      </template>
	    </el-table-column>-->
	  </el-table>

		<!--分页-->
  <div class="block">
    <el-pagination
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
      :current-page.sync="currentPage"
      :page-sizes="[40, 80, 120, 200]"
      :page-size="pageSize"
      layout="total, prev, pager, next, jumper, sizes"
      :total="total">
    </el-pagination>
  </div>

  <!-- 修改标签 -->
  <el-dialog :title="updateTagTitle" :visible.sync="updateTagFormVisible" width="30%" >
    <el-form :model="updateTagForm" :rules="updateTagRules" ref="updateTagForm">
      <el-form-item label="标签" :label-width="formLabelWidth" prop="tagUid">
        <el-select
          @input="updateTagChange"
          v-model="tagValue"
          multiple
          size="small"
          placeholder="请选择"
          style="width: 80%"
          filterable
        >
          <el-option
            v-for="item in tagData"
            :key="item.uid"
            :label="item.content"
            :value="item.uid"
          ></el-option>
        </el-select>
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button @click="updateTagFormVisible = false">取 消</el-button>
      <el-button type="primary" @click="submitUpdateTagForm">确 定</el-button>
    </div>
  </el-dialog>

	  <!-- 添加或修改对话框 -->
		<el-dialog :title="title" :visible.sync="dialogFormVisible">
		  <el-form :model="form" :rules="rules" ref="form">
        <el-form-item label="图集ID" :label-width="formLabelWidth">
          <span>{{form.uid}}</span>
        </el-form-item>
		    <el-form-item label="图集名称" :label-width="formLabelWidth" prop="name">
		      <el-input v-model="form.name" auto-complete="off"></el-input>
		    </el-form-item>
        <el-form-item label="图集模特" :label-width="formLabelWidth" prop="model">
          <el-input v-model="form.model" auto-complete="off"></el-input>
        </el-form-item>
        <el-form-item label="出品方" :label-width="formLabelWidth" prop="producer">
          <el-input v-model="form.producer" auto-complete="off"></el-input>
        </el-form-item>
        <el-form-item label="标签" :label-width="formLabelWidth" prop="tagUid">
          <el-select
            @input="contentChange"
            v-model="tagValue"
            multiple
            size="small"
            placeholder="请选择"
            style="width:210px"
            filterable
          >
            <el-option
              v-for="item in tagData"
              :key="item.uid"
              :label="item.content"
              :value="item.uid"
            ></el-option>
          </el-select>
        </el-form-item>
		  </el-form>
		  <div slot="footer" class="dialog-footer">
		    <el-button @click="dialogFormVisible = false">取 消</el-button>
		    <el-button type="primary" @click="submitForm">确 定</el-button>
		  </div>
		</el-dialog>

  <!--图集图片信息-->
  <el-drawer :visible.sync="atlasFormVisible"  :direction="direction" :size="size">
    <el-form  :model="atlasForm" :span="50" ref="atlasForm">
      <el-col :span="9">
        <el-form-item label="图集名称:" :label-width="formLabelWidth" prop="name">
          <span >{{atlasForm.name}}</span>
        </el-form-item>
      </el-col>
      <el-col :span="3">
        <el-form-item label="ID:" :label-width="formLabelWidth" prop="uid" >
          <span >{{atlasForm.uid}}</span>
        </el-form-item>
      </el-col>
      <el-col :span="4">
        <el-form-item label="模特:" :label-width="formLabelWidth" prop="model">
          <span >{{atlasForm.model}}</span>
        </el-form-item>
      </el-col>
      <el-col :span="6">
        <el-form-item label="出品商:" :label-width="formLabelWidth" prop="producer">
          <span >{{atlasForm.producer}}</span>
        </el-form-item>
      </el-col>
      <el-col :span="2" justify="end">
        <el-button @click="handleEdit()" type="primary" size="small" v-permission="'/pictureAtlas/edit'">编辑</el-button>
      </el-col>

      <el-tabs class="scroll"
        v-model="activeName"
        type="border-card"
        tab-position="left"
      >
        <el-row >
          <el-col
            v-for="(picture, index) in pictureData"
            :key="picture.uid"
            style="padding: 6px"
            :xs="24"
            :sm="12"
            :md="12"
            :lg="6"
            :xl="4"
          >
            <el-card
              :body-style="{ padding: '0px', textAlign: 'center' }"
              shadow="always"
            >
              <!--<input style="position: absolute;z-index: 100;" type="checkbox" :id="picture.uid" :checked="pictureUids.indexOf(picture.uid)>=0" @click="checked(picture)">-->
              <el-image class="showimg"
                :src="picture.pictureUrl"
                style="cursor:pointer"
                fit="cover"
                @click="showPicture(picture.pictureUrl)"
              />
              <div @click="showPicture(picture.pictureUrl)">
                <span class="media-title" v-if="picture.createTime">{{picture.createTime}}</span>
                <span class="media-title" v-else>图片 {{index + 1}}</span>
              </div>
            </el-card>

          </el-col>
        </el-row>

      </el-tabs>


    </el-form>
    <div slot="footer" class="dialog-footer">
    </div>
  </el-drawer>

		<CheckPhoto v-if="!isFirstPhotoVisible" @choose_data="getChooseData" @cancelModel="cancelModel" :photoVisible="photoVisible" :photos="photoList" :files="fileIds" :limit="1"></CheckPhoto>

  <el-dialog :visible.sync="dialogPictureVisible" fullscreen style="text-align: center">
    <img :src="dialogImageUrl" alt="">
  </el-dialog>

  </div>
</template>

<script>
import {
  getPictureAtlasList,
  addPictureAtlas,
  updateTag,
  editPictureAtlas,
  getResourceList,
} from "@/api/pictureAtlas";
import {
  getPictureList,
} from "@/api/picture";
import {getListByDictTypeList} from "@/api/sysDictData"
import CheckPhoto from "../../components/CheckPhoto";
import { getTagList } from "@/api/pictureTag";

export default {
  components: {
    CheckPhoto
  },
  created() {
    this.getDictList();
    this.pictureAtlasList();
    // 获取标签列表
    this.tagList();
    this.resourceList();
    // this.initpictureAtlasList()
  },
  data() {
    return {
      direction: 'ltr',
      size: '100%',
      dialogImageUrl: "", //图片显示地址
      tableData: [],
      atlasForm:{
        uid: null,
        id: null,
        name: null,
        fileUid: null,
        tagUid: null,
        model: null,
        producer: null,
        isShow: null,
      },
      form: {
        uid: null,
        name: null,
        fileUid: null,
        tagUid: null,
        model: null,
        producer: null
      },
      updateTagForm: {
        uid: null,
        tagUid: null
      },
      queryParams:{
        keyword: "",
        tagUid: "", //标签搜索
        createTime: "", //创建时间搜索
        storageTime: "", //图集图片更新时间搜索
        publishKeyword: "", // 发布 搜索
        originalKeyword: "", // 原创 搜索
        typeKeyword: "", // 文章类型
      },
      isChange: false, // 表单内容是否改变
      pictureAtlasUid: undefined, // 当前选中的图片分类uid
      dialogPictureVisible: false,
      changeCount: 0, // 改变计数器
      pictureUids: [], //图片uid集合
      tagData: [], //标签数据
      resourceData: [], //来源数据
      pictureData: [], //图片数据
      tagValue: [], //保存选中标签id(编辑时)
      tagOptions: [], //标签候选框
      multipleSelection: [], //多选，用于批量修改标签
      loading: true,
      dialogVisible: false, //控制增加框和修改框的显示
      currentPage: 1,
      total: null,
      pageSize: 40,
      keyword: "",
      title: "增加图集",
      updateTagTitle: "修改标签",
      formLabelWidth: "120px", //弹框的label边框
      dialogFormVisible: false,
      updateTagFormVisible: false,
      atlasFormVisible: false,
      isEditForm: false,
      photoVisible: false, //控制图片选择器的显示
      photoList: [],
      yesNoDictList: [], // 是否字典
      fileIds: "",
      activeName:0,
      icon: false, //控制删除图标的显示
      isFirstPhotoVisible: true, // 图片选择器是否首次显示【用于懒加载】
      rules: {
        name: [
          {required: true, message: '标题不能为空', trigger: 'blur'},
        ],
        tagUid: [
          {required: true, message: '标签不能为空', trigger: 'blur'},
        ],
        sort: [
          {required: true, message: '排序字段不能为空', trigger: 'blur'},
          {pattern: /^[0-9]\d*$/, message: '排序字段只能为自然数'},
        ]
      },
      updateTagRules: {
        tagUid: [
          {required: true, message: '标签不能为空', trigger: 'blur'},
        ]
      }
    };
  },

  methods: {
    pictureAtlasList: function() {
      var params = {};
      params.keyword = this.queryParams.keyword
      params.tagUid = this.queryParams.tagUid
      params.createTime = this.queryParams.createTime;
      params.storageTime = this.queryParams.storageTime
      params.resource = this.queryParams.resource
      params.pageSize =  this.pageSize
      params.currentPage = this.currentPage
      getPictureAtlasList(params).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },
    tagList: function() {
      var tagParams = {};
      tagParams.pageSize = 1000;
      tagParams.currentPage = 1;
      getTagList(tagParams).then(response => {
        this.tagData = response.data.records;
        this.tagOptions = response.data.records;
      });
    },
    resourceList: function() {
      getResourceList().then(response => {
        this.resourceData = response.data;
      });
    },
    pictureList() {
      var params = {};
      params.currentPage = 1;
      params.pictureAtlasUid = this.atlasForm.uid;
      params.pageSize = 1000;
      getPictureList(params).then(response =>{
        this.pictureData = response.data.records
      });
    },


    /**
     * 字典查询
     */
    getDictList: function () {
      var dictTypeList =  ['sys_yes_no']
      getListByDictTypeList(dictTypeList).then(response => {
        if (response.code == this.$ECode.SUCCESS) {
          var dictMap = response.data;
          /*this.yesNoDictList = dictMap.sys_yes_no.list
          if(dictMap.sys_yes_no.defaultValue) {
            this.yesNoDefault = parseInt(dictMap.sys_yes_no.defaultValue);
          }*/
        }
      });
    },

    showPicture: function(url) {
      this.dialogPictureVisible = true
      this.dialogImageUrl = url
    },

    //点击单选
    checked: function(data) {
      let idIndex = this.pictureUids.indexOf(data.uid);
      if (idIndex >= 0) {
        //选过了
        this.pictureUids.splice(idIndex, 1);
      } else {
        this.pictureUids.push(data.uid);
      }
    },
    // 内容改变，触发监听
    contentChange: function() {
      this.form.tagUid = this.tagValue.join(",");
    },
    // 内容改变，触发监听
    updateTagChange: function() {
      this.updateTagForm.tagUid = this.tagValue.join(",");
    },
    handleFind: function() {
      this.currentPage = 1
      this.pictureAtlasList();
    },
    handleManager: function(row) {
      var uid = row.uid;
      this.$router.push({
        path: "picture",
        query: { pictureAtlasUid: uid }
      });
    },
    getFormObject: function() {
      var formObject = {
        uid: null,
        name: null,
        fileUid: null,
        sort: 0,
        isShow: this.yesNoDefault,
      };
      return formObject;
    },
    //弹出选择图片框
    checkPhoto: function() {
      this.photoList = [];
      this.fileIds = "";
      this.photoVisible = true;
      this.isFirstPhotoVisible = false
    },
    getChooseData(data) {
      var that = this;
      this.photoVisible = false;
      this.photoList = data.photoList;
      this.fileIds = data.fileIds;
      var fileId = this.fileIds.replace(",", "");
      if (this.photoList.length >= 1) {
        this.form.fileUid = fileId;
        this.form.photoList = this.photoList;
      }
    },
    //关闭模态框
    cancelModel() {
      this.photoVisible = false;
    },
    deletePhoto: function() {
      this.form.photoList = null;
      this.form.fileUid = "";
    },
    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.pictureAtlasList();
    },
    //改变页码
    handleCurrentChange(val) {
      var that = this;
      //改变当前所指向的页数
      this.currentPage = val;
      this.pictureAtlasList();
    },
    //点击新增
    handleAdd: function() {
      this.title = "增加图集"
      this.dialogFormVisible = true;
      this.form = this.getFormObject();
      this.isEditForm = false;
      this.tagValue = [];
    },
    //点击编辑
    handleEdit: function() {
      this.title = "编辑图集"
      this.dialogFormVisible = true;
      this.isEditForm = true;
      this.form = this.atlasForm;
      this.tagValue = [];
      if (this.form.tagUid != undefined){
        var tagValue = this.form.tagUid.split(",");
        for (var a = 0; a < tagValue.length; a++) {
          if (tagValue[a] != null && tagValue[a] != "") {
            this.tagValue.push(tagValue[a]);
          }
        }
      }
    },


    // 改变多选
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleUpdateTag() {
      if(this.multipleSelection.length <= 0 ) {
        this.$commonUtil.message.success("请先选中需要修改标签的图集!")
        return;
      }
      this.updateTagTitle = "修改标签"
      this.updateTagFormVisible = true;
      this.form = this.getFormObject();
      this.tagValue = [];
    },
    handleAtlas(row) {
      /*if(this.multipleSelection.length <= 0 ) {
        this.$commonUtil.message.error("请先选中图集!")
        return;
      }*/
      this.atlasFormVisible = true;
      this.atlasForm.id = row.id;
      this.atlasForm.uid = row.uid;
      this.atlasForm.name = row.name;
      this.atlasForm.model = row.model;
      this.atlasForm.producer = row.producer;
      this.atlasForm.tagUid = row.tagUid;
      this.atlasForm.isShow = row.isShow;
      // query: { pictureAtlasUid: row.uid }
      this.pictureList();
    },
    submitForm: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log("校验出错")
        } else {
          if (this.isEditForm) {
            editPictureAtlas(this.form).then(response => {
              this.$commonUtil.message.success(response.message)
              this.dialogFormVisible = false;
              this.pictureAtlasList();
            });
          } else {
            addPictureAtlas(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
              } else {
                this.$commonUtil.message.error(response.message)
              }
              this.dialogFormVisible = false;
              this.pictureAtlasList();
            });
          }
        }
      })
    },

    submitUpdateTagForm: function() {
      this.$refs.updateTagForm.validate((valid) => {
        if(!valid) {
        } else {
          for(var i=0;i<this.multipleSelection.length;i++){
            this.multipleSelection[i].tagUid = this.updateTagForm.tagUid;
          }
          updateTag(this.multipleSelection).then(response => {
            if (response.code == this.$ECode.SUCCESS) {
              this.$commonUtil.message.success(response.message)
            } else {
              this.$commonUtil.message.error(response.message)
            }
            this.updateTagFormVisible = false;
            this.pictureAtlasList();
          });
        }
      })
    }
  }
};
</script>
<style scoped>
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  margin: 0, 0, 0, 10px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 195px;
  height: 105px;
  line-height: 105px;
  text-align: center;
}
.imgBody {
  width: 195px;
  height: 105px;
  border: solid 2px #ffffff;
  float: left;
  position: relative;
}
.uploadImgBody {
  margin-left: 5px;
  width: 195px;
  height: 105px;
  border: dashed 1px #c0c0c0;
  float: left;
  position: relative;
}
.uploadImgBody :hover {
  border: dashed 1px #00ccff;
}
.inputClass {
  position: absolute;
}
/*.el-table__body-wrapper::-webkit-scrollbar {
  position: relative;
   width: 8px;
 }*/
.show_table {
  background-color: #dde;
  width: 100%;
  overflow: auto;
  position: relative;
}
.scroll {
  width: 100%;
  height: calc(100vh - 131px);
  overflow: hidden;
  overflow-y: auto;
}
.showimg {
  width: 357px;
  height: 467px;
  background-color: royalblue;

}
</style>
